import type LSP from "vscode-languageserver-protocol";
import { LanguageServerClient, LanguageServerClientOptions, LSPNotifyMap, LSPRequestMap, Notification } from "./types.js";
import { LanguageServerPlugin } from "../extension/plugin.js";
export declare class LanguageServerClientImpl implements LanguageServerClient {
    ready: boolean;
    capabilities: LSP.ServerCapabilities | null;
    initializePromise: Promise<void>;
    private rootUri;
    private workspaceFolders;
    private autoClose?;
    private transport;
    private requestManager;
    private client;
    private timeout;
    private initializationOptions;
    clientCapabilities: LanguageServerClientOptions["capabilities"];
    private plugins;
    constructor(options: LanguageServerClientOptions);
    protected getInitializationOptions(): LSP.InitializeParams["initializationOptions"];
    initialize(): Promise<void>;
    started(): Promise<boolean>;
    close(): void;
    textDocumentDidOpen(params: LSP.DidOpenTextDocumentParams): Promise<LSP.DidOpenTextDocumentParams>;
    textDocumentDidChange(params: LSP.DidChangeTextDocumentParams): Promise<LSP.DidChangeTextDocumentParams>;
    textDocumentHover(params: LSP.HoverParams): Promise<LSP.Hover>;
    textDocumentCompletion(params: LSP.CompletionParams): Promise<LSP.CompletionItem[] | LSP.CompletionList | null>;
    completionItemResolve(item: LSP.CompletionItem): Promise<LSP.CompletionItem>;
    textDocumentDefinition(params: LSP.DefinitionParams): Promise<LSP.Definition | LSP.LocationLink[] | null>;
    textDocumentCodeAction(params: LSP.CodeActionParams): Promise<(LSP.Command | LSP.CodeAction)[] | null>;
    textDocumentRename(params: LSP.RenameParams): Promise<LSP.WorkspaceEdit | null>;
    textDocumentPrepareRename(params: LSP.PrepareRenameParams): Promise<LSP.PrepareRenameResult | null>;
    attachPlugin(plugin: LanguageServerPlugin): void;
    detachPlugin(plugin: LanguageServerPlugin): void;
    protected request<K extends keyof LSPRequestMap>(method: K, params: LSPRequestMap[K][0], timeout: number): Promise<LSPRequestMap[K][1]>;
    protected notify<K extends keyof LSPNotifyMap>(method: K, params: LSPNotifyMap[K]): Promise<LSPNotifyMap[K]>;
    protected processNotification(notification: Notification): void;
}
//# sourceMappingURL=client.d.ts.map