import type { Text } from "@codemirror/state";
import type { EditorView } from "@codemirror/view";
import type * as LSP from "vscode-languageserver-protocol";
export declare function posToOffset(doc: Text, pos: {
    line: number;
    character: number;
}): number | undefined;
export declare function posToOffsetOrZero(doc: Text, pos: {
    line: number;
    character: number;
}): number;
export declare function offsetToPos(doc: Text, offset: number): {
    character: number;
    line: number;
};
export declare function formatContents(contents: LSP.MarkupContent | LSP.MarkedString | LSP.MarkedString[] | undefined): string;
export declare function toSet(chars: Set<string>): string;
export declare function prefixMatch(items: LSP.CompletionItem[]): RegExp[];
export declare function isLSPTextEdit(textEdit?: LSP.TextEdit | LSP.InsertReplaceEdit): textEdit is LSP.TextEdit;
export declare function isLSPMarkupContent(contents: LSP.MarkupContent | LSP.MarkedString | LSP.MarkedString[]): contents is LSP.MarkupContent;
export declare function showErrorMessage(view: EditorView, message: string): void;
//# sourceMappingURL=utils.d.ts.map